Bug 33426

Summary: Implement JIT_OPTIMIZE_NATIVE_CALL for WinCE
Product: WebKit Reporter: Patrick R. Gansterer <paroga>
Component: JavaScriptCoreAssignee: Nobody <webkit-unassigned>
Status: RESOLVED FIXED    
Severity: Normal CC: commit-queue, joybro201, laszlo.gombos, skyul, zherczeg
Priority: P2    
Version: 528+ (Nightly build)   
Hardware: Other   
OS: Other   
Attachments:
Description Flags
The patch
oliver: review-, paroga: commit-queue-
The patch
none
The patch (added JSVALUE32_64) none

Description Patrick R. Gansterer 2010-01-09 13:03:26 PST
See patch
Comment 1 Patrick R. Gansterer 2010-01-09 13:16:51 PST
Created attachment 46214 [details]
The patch

It was a hard task, but i think it's working now.
Because i couldn't find any valuable information about the calling conventions an WinCE, i've done this via a kind of reverse engineering :-/

Since run-javascriptcore-tests isn't woking, i only wan't some feedback if this patch looks sane.

I'll post a comment when i've run all the tests to ensure that i doesn't introduce a regression.
Comment 2 Oliver Hunt 2010-01-10 20:16:47 PST
Comment on attachment 46214 [details]
The patch

I don't think it's right to be detecting wince based on the compiler, isn't there a PLATFORM(WINCE) ?
Comment 3 Patrick R. Gansterer 2010-01-16 08:11:35 PST
(In reply to comment #2)
> I don't think it's right to be detecting wince based on the compiler, isn't
> there a PLATFORM(WINCE) ?
Yes, but all other ifdefs are COMPILER(XY) too.
So the other COMPILER(MSVC) should be changed to OS(WIN)?

But anyway, can you give me feedback about my implementation? Does it look sane?
Comment 4 Patrick R. Gansterer 2010-01-26 11:21:08 PST
Created attachment 47424 [details]
The patch

changed COMPILER(MSVC) to OS(WINCE)
Comment 5 Zoltan Herczeg 2010-02-01 04:06:00 PST
Patch seems OK for me. However, the patch supports only JSvalue32. We plan to enable JSValue32_64 support for ARM (as 75% voted for it). The NATIVE call support for this mode started from line 252 in the very same file (JITOpcodes.cpp). Could you add WinCE support for this mode as well?
Comment 6 Patrick R. Gansterer 2010-02-20 09:52:10 PST
Created attachment 49128 [details]
The patch (added JSVALUE32_64)

Sorry for the long delay.
It was like reverse engineering again.
Comment 7 Zoltan Herczeg 2010-02-20 10:30:08 PST
> Sorry for the long delay.
> It was like reverse engineering again.

GCC is no better.

The patch looks good to me. (but I am not a reviewer)
Comment 8 Eric Seidel (no email) 2010-03-05 13:46:44 PST
Comment on attachment 49128 [details]
The patch (added JSVALUE32_64)

Looks non-harmful.  rs=me.
Comment 9 WebKit Commit Bot 2010-03-06 03:31:22 PST
Comment on attachment 49128 [details]
The patch (added JSVALUE32_64)

Clearing flags on attachment: 49128

Committed r55615: <http://trac.webkit.org/changeset/55615>
Comment 10 WebKit Commit Bot 2010-03-06 03:31:27 PST
All reviewed patches have been landed.  Closing bug.